QGIS Application - Bug report #10489
QGIS Server getcapabilites response is not WMS compliant
2014-06-06 12:56 PM - aperi2007 -

Status: Closed

Priority: High

Assignee: Marco Hugentobler

Category: QGIS Server

Affected QGIS version:2.2.0 Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 18901
Description

Hi,

the response of the QGIS Server trunk version don't seem to be WMS Compliant.

| tested it using XML Spy Enterprise and it response the GetLegendGraphics is put in wrong place.

| try using this request:

http://www502.regione.toscana.it/geoscopio qg/cgi-bin/qgis _mapserv?map=continuum_geologico rt.qgs&#38;SERVICE=WMS&#38;r
quest=GetCapabilities&#38;version=1.3.0

Also | attach the image from my xmlispy with hard sentence.

Perhaps there some setting to set QGIS to response a valid xml for OGC clients ?

Thx.

Associated revisions

Revision b3a708fb - 2014-06-07 07:19 PM - Jiirgen Fischer

add xsd schema to validate mapserver capabilities (might fix #10489)

History

#1 - 2014-06-06 02:26 PM - aperi2007 -
- File error_validation110.gif added

| test with a version=1.1.0 request.
http://www502.regione.toscana.it/geoscopio_qg/cgi-bin/qgis_mapserv?map=continuum_geologico_rt.qgs&#38;SERVICE=WMS&#38;request=GetCapabilities&#38;version=1.3.0
http://www502.regione.toscana.it/geoscopio_qg/cgi-bin/qgis_mapserv?map=continuum_geologico_rt.qgs&#38;SERVICE=WMS&#38;request=GetCapabilities&#38;version=1.3.0

1 <?xml version="1.0" encoding="UTF-8"?=
2 F1<WMS_Capabilities xminsxsi="http:/fwww w3.0rg/2001/XMLSchema-instance” version="[IKL" xmins="http:/www.opengis.netiwms" xsi-schemalocation="http:/fwww.opengis.netwms
http:/fschemas.opengis.net/wms/1.3.0/capabilities_1_3_0.xsd"=
3 = <Senices
4 <Mame>WMS</Name=
5 =Title>Regione Toscana - Geologia</Title>
6 <Abstract=Senizio WMS di Regione Toscana (Sistema Informativo Territoriale ed Ambientale) per la consultazione dei dati relativi al "Continuum Geologico”. | dataset sono arricchiti dei dz
"BD Frane" e "BD Geom". La scala di impiego del WMS va da 1:1 a 1:5.000.000. | singoli strati possono avere intervalli di impiego piu’ ristretti, si veda, percio’, le informazioni sui singoli strz
I o <KeywordList>
8 <Keyword=geology=</Keyword=
9 <Keyword=tuscany</Keyword=
10 </KeywordList=
" <0OnlineResource xlink:type="simple" xmins:xlink="http:/fwww.w3.0rg/1999/xlink" xlink:href="http:/Amw502. regione toscana.it/geoscopio_qg/cgi-bin/qgis_mapserv?map=continuum_geolog
12 & <Contactinformationz
13 = <ContactPersonPrimary>
14 <ContactPerson=Sistema Informativo Territoriale ed Ambientale</ContactPerson=
Text Grid Schema WSDL ¥BRL Authentic Browser

@ qgis_mapserv110.xml ‘

lessages

|l

[8yiysysyaysyey

w|al 45| 8] X| ErmorLimit 100| Hide Smart Fix |

= 0 File D:\temp\ggis_mapserv110.xml iz not valid.
“alue "1.1.0"is not allowed for attribute "version' @& .
Annotations of element "wms:WNS_Capabiities' ZE (see below)

rror location: WMS Capabilties / @wersion
Details

ﬂ Element <Getl egendGraphic> iz not alowed under element <Request= .

Also it seem invalid.

Ip

#2

ut an image with the error message from xml-spy.

- 2014-06-06 02:30 PM - aperi2007 -

- File error_validation111.gif added

lastly

| tested also the version=1.1.1

2025-04-27

¢ Change value of attribute version="..." to itz fixed default value "1.3.0°.
¥ Delete attribute version="..." since it has a fixed default value 1.3.0'.
81 - fGets

82 {/HTTP:=

83 </DCPType=

84 - =/GetStyles>

o5 o JEEE

86 <Format=svg</Format=>
87 <Format=>png=</Format=
88 <Format=pdf</Format=
89 <DCPTypex

a0 [<HTTP=

™ { «Gets

92

93 - <iGets

94 - iHTTP=

95 - </DCPType=

96 <fGetPrint=

Text Grid Schema

WSDL XBRL Authentic

=OnlineResource xlink:type="simple" xmlins:xlink="http:/fwww w3.org/1999/xlink" xlink:href="http:/fwww502 regione toscana.it/geoscopio_

@ qgis_mapservi11.xml

fdessages

~ wla| D@ 88 8] X| ErorLimit: 100] Hide Smart Fix|

= B File D-\temp\ggis_mapserv111 xml is not valid.

Error location: WWMT MS Capabilities / Capability / Request / GetPrint
Detailz
- ﬂ Element =GetPrint= has not been declared.

ﬂ Content model of element <Reguest-0HE dizallows element <GetPrint= at this position.

AR

RE| ﬂ Required attribute
@ [ Required attribute
- [ Required attribute
A [ Required attribute
-3 [ Required attribute
@ [ Required attribute
-3 [ Required attribute
-F [ Required attribute
- [ Required attribute
- [ Required attribute
- [ Required attribute
-@ [ Required attributs
-@ [ Required attribute
-@ [ Required attribute

"width' @@ is missing in element =LegendURL=.
"height’' @& i= missing in element =LegendURL=.
"width' @@ is missing in element =LegendURL=.
"height' @& i= missing in element =LegendURL=.
"width' @@ is missing in element =LegendURL=.
"height' @& i= missing in element =LegendURL=.
"width' @& is mis=sing in element =LegendURL =
‘height' @@ iz miz=ing in element <LegendURL=.
"width' & is mis=ing in element <LegendURL =
‘height'@@ is missing in element <LegendURL=
"width' & is mis=sing in element =LegendURL =
‘height'@@ is missing in element <LegendURL=
"width' & is miz=ing in element <LegendURL =
‘height'EE is mig=ing in element <LegendURL =

¥ Delete element <GetPrint>.

Again it is invalid, seem that the GetPrint command in unknow to xsd 1.1.1

#3 - 2014-06-06 11:58 PM - aperi2007 -

- File qgis_mapserv_getcapa response.zip added

| send a wrong xml (the firefox transform it in an html file).

SO | resend the right.

#4 - 2014-06-07 12:07 AM - aperi2007 -
- File img2.gif added

Hi,
| do more tests.
The problem is the GetLegendGraphic that is put in wrong position.

| compare with a VALID getcapabilities response from MapServer.

| attach an image to show where MapServer will put the GetLegendGraphics tag.
#5 - 2014-06-07 12:11 AM - aperi2007 -

- File img2.gif added

NO .

Drammatically error.

&

&

)

= XML

WMS_Capabilities

[

Text Grid

version
xmins
xmins:sid
xmins:xsi
xmins:ms

i Comment

> Service
& Capability

Schema WSsDL

xsi:schemalLoca..

1.3.0

http:/iwww.opengis.netiwms

hitp.ffveww. opengis.netisid
hitpifeewrw w3 orgl2001/ XM LS chema-instance
http:#imapserver gis.umn.edu/mapserver

. hitp:fiwwew . opengis.netiwms hitpoi'schemas.opengis.netwmsd1.3.0/capabilities_1_3_0.x=sd

hitp:ifvewrw . opengis.net’zid hitpifschemas.opengis.net’zld/1 . 1.0/=ld_capabilities.xsd
http:/imapserver gis.umn.edu/mapserver

http:ffvewrw 502 regione toscana. itw msraster/com. rt. wms. RTmap/wms ?map=wmsambamm&amp
:map_resolution=91&amp;service=WMS&amp; version=1.3.0&amp;reguest=GetSchemaExtension

MapServer version §.5-dev OUTPUT=PNG OUTPUT=JPEG OUTPUT=KWML SUPPORTS=PROJ
SUPPORTS=AGG SUPPORTS=FREETYPE SUPPORTS=CAIRD SUPPORTS=5VG_SYMBOLS
SUPPORTS=RSVG SUPPORTS=ICONV SUPPORTS=FRIBIDI SUPPORTS=VWWS_SERVER
SUPPORTS=WMS_CLEENT SUPPORTS=WFS_SERVER SUPPORTS=WFS_CLIENT
SUPPORTS=WCS_SERVER SUPPORTS=505_SERVER SUPPORTS=GEOS
SUPPORTS=POINT_Z_MW INPUT=JPEG INPUT=POSTGIS INPUT=0GH INPUT=GDAL
INPUT=5SHAPEFILE

Request
GetCapabilities
{} Format textiml
¥ DCPType
= GetMap
> GetFeaturelnfo
~ Exception
> Layer
XBRL Authertic Browser

fEh test_qgis.xm l B

Messages

mapserver_getcapa_response.xml

Z xalnmE ajss X

o File D:\temp\mapserver_getcapa_response.xml is valid.

| put a wrong image that show the wrong getcapabilites of qgis-server.

9)

Now | put the right image with the right position.

sorry for noise.

#6 - 2014-06-07 12:14 AM - aperi2007 -

- File img3.gif added

2025-04-27
PO R | L L LB VSR e e a1 S Ed g B

ko

i XML
a WMS_Capabilities
= xmins:xsi hitp:ihw v w3 org/2001XMLSchema-instance
= version 1.3.0
= xmlins hitp:ifwww. opengis.nethwms.
= xsi:schemaloca... hitp./fwww.opengis.net'wms hitp://schemas.epengis.net/wms/1.3.0/capabilities_1_3_0.x=sd
> Service
| Capability
4 Request
> GetCapabilities
> GetMap
> GetFeaturelnfo
Format (2)
> GetStyles
L > GetPrint
> Exception
_ 15 = Layer queryable=1
Kl
Text Grid Schema WsDL XBRL Authentic Browser

mapserver_getcapa_response.xml

test_qg's.xml I

Messages

wlal O|E|E| 22| 8] »| Erorlimit 100] Hide Smart Fix |

=1 e File D:\tempitest_ggis.xml is not valid.

ﬂ Element =Getl egendGraphic= is not allowed under element <Reguest- 0.
Reaszon: The following elements are expected at this location (see below)
Annotations of element "wms:Reguest' T (see below)

Error location: WMS Capabilties / Capability / Reguest / Getl egendGraphic
Details

will show the wrong position used by qgis-server.
i hope to not wrong again to send the image. :)
Regards.
#7 - 2014-06-07 06:02 AM - aperi2007 -
- File img4.gif added
Hi, more informations.
The question is not the positizion, but there is more oproblems.
Firstly the GetCapabilities should be prefixed using a specific prefixname as example "sld"
so the tag become

<sld:GetLegendGraphic>

<Format>image/jpeg</Format>

<Format>image/png</Format>
<DCPType>

2025-04-27

;I #» Delete element sequence <GetLegendGraphic>. <GetPrint=.
<HTTP>
<Get>

<OnlineResource xlink:type="simple" xmIns:xlink="http://www.w3.0rg/1999/xlink"

xlink:href="http://www502.regione.toscana.it/geoscopio_qg/cgi-bin/qgis_mapserv?map=continuum_geologico_rt.qgs"/>

</Get>

</HTTP>
</DCPType>
</sld:GetLegendGraphic>

And add the used prefix in the namespace list:

<WMS_Capabilities
xmins:xsi="http://www.w3.0rg/2001/XMLSchema-instance" version="1.3.0"
xmins:sld="http://www.opengis.net/sld"
xmins="http://www.opengis.net/wms"

xsi:schemal.ocation="http://www.opengis.net/wms http://schemas.opengis.net/wms/1.3.0/capabilities_1_3_0.xsd http://www.opengis.net/sld

http://schemas.opengis.net/sld/1.1.0/sld_capabilities.xsd">

This resolve the GetCapabilites problem, but after this there are more problems:

Infact

in the GetCapabilites there are also the two tags GetStyles and GetPrint that are not known by xsd of OGC standard.

| study better.

For the GetStyle:

The result was that the GetStyle was introduced in the WMS 1.10, but was definitively dismissed in wms 1.3.0.

This link show the explanation from OGC: http://www.ogcnetwork.net/node/1333

Unfortunately the QGIS-server declare the response WMS 1.3.0.

The GetPrint instead seem to be an invention of QGIS.

So the only choice is remove it.

| dont know why the need to insert in a getcapabilites a non standard tags.

Why this ?

It is pretty unuseful.

The GetCapabilities is useful only to say to a standard client what the Server WMS know of the standard.
Why put in GetCapabilites response a non standard tag that no one client WMS compliant could understand ?
More better to invent an extra request like for example: GetQGISCapabilities,

it is not a standard WMS request so no-one server wms response , instead qgis respond.

Init put all you need.

And leave standard and clean from incompatibility tags the standard GetCapabilities.

| attach an image that show this problem.

2025-04-27
http://www.ogcnetwork.net/node/1333

Andrea.

#8 - 2014-06-07 07:30 AM - aperi2007 -

Hi.

| confirm that the action described resolve the validity problem.

I modify the code of qgis-server adding the prefix and the namespace and schemal.ocation missed.
Also | comment the code for GetStyle and GetPrint in the GetCapability response.

And voila' the response now is VALID.

For me is ok .

Now we have our "qgis-server" compliant with ogc and inspire.

Regards.

#9 - 2014-06-07 08:22 AM - Jiirgen Fischer

Is there any practical problem with this?

#10 - 2014-06-07 09:14 AM - aperi2007 -

| dont know who really use the
tags

GetStyles and GetPrint in the GetCapabilities.

Surely no one of the standard OGC client like Arcgis, QGIS, Autoca, Geotool-based and so on no one could use this two tags.

I don't know if the two web client for qgis like the
"QGIS Web client" and the "Lizmap web client" will use it.

AFAIK the GetCapabilities is a standard OGC world used response. And some proprietary tags in it will break the compatibility.

As example our client based on the GeoTools and based on a rigorous apply of OGC stadard will fail.

Also any other standard client like ArcGIS that use the getcapabilities to understand what layers and what functionalyity will fail if the response is not
standard.

If agree with this consideration.

| could open a PULL for a Patch.

The patch fixe the namespace of getLegendGraphics and remove the tags GetStyle and GetPrint from the GetCapabilities Response.

| tested the patch on my qgis-server (the same of the ticket). Now it is patched and is OGC compliant in the wms 1.3.0 getcapabilities response.

Regards.
#11 - 2014-06-07 10:19 AM - Jiirgen Fischer
- Status changed from Open to Closed

Fixed in changeset commit:"b3a708fbabcbd7af8c28cale46e48a053aef5afe”.

#12 - 2014-06-07 10:32 AM - Jiirgen Fischer

aperi2007 - wrote:

Surely no one of the standard OGC client like Arcgis, QGIS, AutoCAD, Geotool-based and so on no one could use this two tags.

Of course, but they also don't have a problem with it.

I don't know if the two web client for qgis like the "QGIS Web client" and the "Lizmap web client" will use it.

Not sure about Lizmap, but QWC does. GetPrint was introduced for QWC.

AFAIK the GetCapabilities is a standard OGC world used response. And some proprietary tags in it will break the compatibility.

Not really. | don't know any client that checks the validity of the GetCapabilities response.

As example our client based on the GeoTools and based on a rigorous apply of OGC standard will fail.
Also any other standard client like ArcGIS that use the getcapabilities to understand what layers and what functionalyity will fail if the response is not

standard.

Did you verify that that's actually true? ArcGIS 10.1 apparently doesn't have a problem with QGIS server. And invalid responses might do no harm at all
as long as all the expected stuff is actually there - which is the case. Clients shouldn't be to picky as there are lots of servers out that have "alternative"

interpretations of the spec.
If agree with this consideration. | could open a PULL for a Patch. The patch fixe the namespace of getLegendGraphics and remove the tags

GetStyle and GetPrint from the GetCapabilities Response.

| suppose that would break existing clients (that are not that picky on validity). Does QGIS Desktop still work (ie. does it show the legend)? | suppose
commit:b3a708fba doesn't and still should make the response valid. Although letting the schemalocation point at an extended schema might be in a grey
area of the spec. Maybe there is a cleaner way to extend the schema without introducing a different namespace. | didn't find any, but I'm not an XML
expert. xmlpatternsvalidator at least doesn't complain anymore.

| tested the patch on my qgis-server (the same of the ticket). Now it is patched and is OGC compliant in the wms 1.3.0 getcapabilities response.

Which clients did you use to test?

#13 - 2014-06-07 10:55 AM - aperi2007 -
- Status changed from Closed to Reopened
Hi,
| see your solution.

Unfortunately if is a license violation of License.

Please read this
http://schemas.opengis.net/wms/ReadMe.txt

and after this
http://www.opengeospatial.org/ogc/legal/

More important this paragraph:

The materials contained in the Site may be downloaded or copied provided that ALL copies retain the copyright and any other proprietary notices

>contained on the materials. No material may be modified, edited or taken out of context such that its use creates a false or misleading statement or

>impression as to the positions, statements or actions of OGC.

AFAIK you cannot download the XSD of OGC and change it inserting in it the new tags.

You should rewrite it from scratch.
Not so easy.

#14 - 2014-06-07 11:06 AM - aperi2007 -

| rsponde between rows:

aperi2007 - wrote:

Surely no one of the standard OGC client like Arcgis, QGIS, AutoCAD, Geotool-based and so on no one could use this two tags.

Of course, but they also don't have a problem with it.

| know how work arcgis.

| use arcgis 9.3.1

It call for capabilities and show all the layers it find.

You know it ?

I don't know if the two web client for qgis like the "QGIS Web client" and the "Lizmap web client" will use it.

Not sure about Lizmap, but QWC does. GetPrint was introduced for QWC.

> AFAIK the GetCapabilities is a standard OGC world used response. And some proprietary tags in it will break the compatibility.

Not really. | don't know any client that checks the validity of the GetCapabilities response.

The GetCapabilities is a standard OGC. So it MUST BE used with a standard OGC xsd.
You cannot change it otherwise it is not compiant.
ANY PUBLIC ADMINISTRATION IN EUROPE IS CALLED TO USE INPSIRE.

2025-04-27 9/20


http://schemas.opengis.net/wms/ReadMe.txt
http://www.opengeospatial.org/ogc/legal/

The use of a server that is not inspire compliant (ogc compliant) is a violation of european laws.

And cannot be fund with public money.
As example our client based on the GeoTools and based on a rigorous apply of OGC standard will fail. Also any other standard client like ArcGIS

that >use the getcapabilities to understand what layers and what functionalyity will fail if the response is not standard.

Did you verify that that's actually true? ArcGIS 10.1 apparently doesn't have a problem with QGIS server. And invalid responses might do no harm
at all >as long as all the expected stuff is actually there - which is the case. Clients shouldn't be to picky as there are lots of servers out that have

>"alternative" interpretations of the spec.

In Italy a public administration cannot say to an user "hey buy a arcgis 10 license " because your arcgi 9.3 don't work with my incompatible OGC server.
| Guess also in other european menber states is the same.

If agree with this consideration. | could open a PULL for a Patch. The patch fixe the namespace of getLegendGraphics and remove the tags

GetStyle and >GetPrint from the GetCapabilities Response.

| suppose that would break existing clients (that are not that picky on validity). Does QGIS Desktop still work (ie. does it show the legend)? |
suppose

b3a708fba doesn't and still should make the response valid. Although letting the schemal.ocation point at an extended schema might be in a grey
area of

the spec. Maybe there is a cleaner way to extend the schema without introducing a different namespace. | didn't find any, but I'm not an XML expert.

xmipatternsvalidator at least doesn't complain anymore.

ok, | don' t well explain.
Tne qgis desktop is totally neutral on this problem.

The GetStyles and GetPrint tags ARE NOT present in Mapserver and Geoserver.

IS qgus workng with Mapserver or GeoServer ?

Surely yes.
SO the GetStyles and GetPrint are unusegul for QGIS desktop.

They are added to give a commercial advantege to some web portal solution.
That adopting a non standard OGC solution hope to gain a piece of market.

But a public administration cannot be the funder of a product not interoperable and not compliant with inspire specificitaio

SO | Guess actually the clients of this product are or private subject or PA that don't understand well this question.

But is ESRI and Autocad and so on
will understand this will have no problem to explain well to their new potential client that QGIS server is NOT compliant with Inspire and so is unuseful.

Regards,

Andrea.
#15 - 2014-06-07 11:33 AM - Jiirgen Fischer

- Status changed from Reopened to In Progress

aperi2007 - wrote:

AFAIK you cannot download the XSD of OGC and change it inserting in it the new tags.

| didn't. The schema references the original schema as include and uses the intended element for the extension - just like your approach. Only without

requiring a separate namespace and a prefix for the operation. Not sure if there is a (more canonical?) way to do that.

#16 - 2014-06-07 11:58 AM - aperi2007 -

sorry.
| dont understand.

AFAIK the better solution is add the namespace.

This is the code to set the change in the ggiswmsserver.cpp.
wmsCapabilitiesElement.setAttribute( "xmins:xsi", "http://www.w3.0rg/2001/XMLSchema-instance" );
--> wmsCapabilitiesElement.setAttribute( "xmins:sld", "http://www.opengis.net/sld" );
--> wmsCapabilitiesElement.setAttribute( "xsi:schemalocation", "http://www.opengis.net/wms
http://schemas.opengis.net/wms/1.3.0/capabilities_1_3 0.xsd http://www.opengis.net/sld http://schemas.opengis.net/sld/1.1.0/sld_capabilities.xsd

")

and also this:
/lwms:GetLegendGraphic
--> elem = doc.createElement( "sld:GetLegendGraphic"/*wms:GetLegendGraphic*/ );

This code correct the GetLegendGraphics problem.

Obviously still remain to resolve the presence of GetStyle e GetPrint.

#17 - 2014-06-07 12:22 PM - zicke -

QGIS server has a GetProjectSettings request which has a lot more information for QGIS webclient (which the GetPrint tag is for). In earlier times there

was no such request and the GetCapabilities request was "abused". Now, probably you can get rid of these vendor things in the GetCababilities response.

Stefan

#18 - 2014-06-07 12:27 PM - Jiirgen Fischer

aperi2007 - wrote:

Not really. | don't know any client that checks the validity of the GetCapabilities response.

The GetCapabilities is a standard OGC. So it MUST BE used with a standard OGC xsd.

I know. But | don't know any client that actually validated the response.
http://schemas.opengis.net/wms/1.3.0/capabilities_1_3_0.xsd
http://www.opengis.net/sld
http://schemas.opengis.net/sld/1.1.0/sld_capabilities.xsd

In ltaly a public administration cannot say to an user "hey buy a arcgis 10 license " because your arcgi 9.3 don't work with my incompatible OGC
server.
I Guess also in other european menber states is the same.

| was just asking if you actually tried any clients and found any that actually fail. Any client that only accepts fully valid GetCapabilities responses will
probably have problems with lots of available WMS servers and also be very slow as validating the schema takes much time. So | suppose in practice no
client will actually do that and hence any client capable to work with any valid schema will be able to ignore elements that it doesn't support and in turn
should also work with QGIS' response. That doesn't mean that QGIS' shouldn't be compliant - it just questions the actual relevance of it.

To me it was unclear if you just suspect that ArcGIS doesn't work or if you actually verified that it has. That | found ArcGIS 10.1 working (and now verified
that 9.2 also appears to work) suggested that it was just a hunch.

#19 - 2014-06-07 12:38 PM - Jiirgen Fischer

aperi2007 - wrote:

sorry. | dont understand.

http://qgis.org/wms_1_3 0.xsd reads:

<?xml version="1.0" encoding="UTF-8"?>
<schema xmins="http://www.w3.0rg/2001/XMLSchema" xmins:wms="http://www.opengis.net/wms"
targetNamespace="http://www.opengis.net/wms">
<include schemaLocation="http://schemas.opengis.net/wms/1.3.0/capabilities_1_3_0.xsd"/>
<element name="GetLegendGraphic" type="wms:OperationType" substitutionGroup="wms:_ExtendedOperation" />
<element name="GetPrint" type="wms:OperationType" substitutionGroup="wms:_ExtendedOperation” />
<element name="GetStyles" type="wms:OperationType" substitutionGroup="wms:_ExtendedOperation" />

</schema>

So the schema wasn't copied.

AFAIK the better solution is add the namespace.

Right, but it might break existing clients and it's unclear to me if there are any clients that would benefit from it.

This is the code to set the change in the qgiswmsserver.cpp.

wmsCapabilitiesElement.setAttribute( "xmins:xsi", "http://www.w3.0rg/2001/XMLSchema-instance" );

--> wmsCapabilitiesElement.setAttribute( "xmins:sid", "http.//www.opengis.net/sld" );

--> wmsCapabilitiesElement.setAttribute( "xsi:schemalLocation", "http://www.opengis.net/wms
http://schemas.opengis.net/wms/1.3.0/capabilities_1_3_0.xsdhttp.//www.opengis.net/sldhttp://schemas.opengis.net/sld/1.1.0/sld_capabilities.xsd" );

If we did that I'd propose a qgis namespace similiar to the above xsd listing all the available extensions (ie. like umn mapserver does).

#20 - 2014-06-07 12:40 PM - aperi2007 -
http://qgis.org/wms_1_3_0.xsd
http://schemas.opengis.net/wms/1.3.0/capabilities_1_3_0.xsd
http://www.opengis.net/sld
http://schemas.opengis.net/sld/1.1.0/sld_capabilities.xsd

QGIS server has a GetProjectSettings request which has a lot more information for QGIS webclient (which the GetPrint tag is for). In
earlier times there was no such request and the GetCapabilities request was "abused". Now, probably you can get rid of these vendor things
in the GetCababilities response.
Stefan
Hi Stefan,

yes your solution is the right think to do.

Put all not ogc compliant things in a not standard request/response couple.
So it can host every new introduced by qgis. And leave the standard response only for standard things.

Thx,

Andrea.

#21 - 2014-06-07 12:44 PM - aperi2007 -

Right, but it might break existing clients and it's unclear to me if there are any clients that would benefit from it.

This is the code to set the change in the qgiswmsserver.cpp.

wmsCapabilitiesElement.setAttribute( "xmins:xsi", "http://www.w3.0rg/2001/XMLSchema-instance" ); --> >wmsCapabilitiesElement.setAttribute(

"xmins:sid", "http://www.opengis.net/sld" ); --> wmsCapabilitiesElement.setAttribute( >"xsi:schemalLocation", "http://www.opengis.net/wms

http://schemas.opengis.net/wms/1.3.0/capabilities_1_3_0.xsd http://www.opengis.net/sld >http.//schemas.opengis.net/sld/1.1.0/sld_capabilities.xsd

vr).
’

If we did that I'd propose a qgis namespace similiar to the above xsd listing all the available extensions (ie. like umn mapserver does).

The client actually don't do any type of validation otherwise they will fails.
This mena thay don't use any standard library to parse and extract informations from the xml response otherwise they fail in invalidity.
This mean the client parse the response manually.
This mean also that QGIS is caged by some manual client that use a non standard and not wms compliant xml response ?
This is the better think that may hope a commercial product like esri.
D)
#22 - 2014-06-07 01:06 PM - Jiirgen Fischer
aperi2007 - wrote:
| | If we did that I'd propose a qgis namespace similiar to the above xsd listing all the available extensions (ie. like umn mapserver does).
The client actually don't do any type of validation otherwise they will fails.

This mena thay don't use any standard library to parse and extract informations from the xml response otherwise they fail in invalidity.

This mean the client parse the response manually.
Not validating doesn't mean that you don't use a standard library and do manual parsing. You can use a standard library and still skip the validation -
actually you probably always will for performance reason unless there is reasonable doubt that the response is correct (eg. for debugging while developing
or if you use an unreliable transport path etc).

This mean also that QGIS is caged by some manual client that use a non standard and not wms compliant xml response?

Extending the GetCapabilities response is covered by the spec - that's what the _ExtendedOperation element is for. | think we're in a grey area now.
AFAICT the spec doesn't clearly state where the schemeLocation should point, there is intended room for extension and validation tools are probably
unable to spot any invalidity now, but we're probably still outside the intended interpretation of the spec as GetCapabilities "shall contain an XML Schema
instance schemal.ocation attribute that binds the “http://www.opengis.net/wms” namespace to the schema in E.1." - which it does - but indirectly ;)

But the solution with the ggis namespace would be fine and valid - although it still might break clients.

#23 - 2014-06-07 02:55 PM - aperi2007 -

Extending the GetCapabilities response is covered by the spec - that's what the _ ExtendedOperation element is for. | think we're in a
grey area now. AFAICT the spec doesn't clearly state where the schemeLocation should point, there is intended room for extension and
validation tools are probably unable to spot any invalidity now, but we're probably still outside the intended interpretation of the

spec as GetCapabilities "shall contain an XML Schema instance schemal ocation attribute that binds the “http://www.opengis.net/wms”
namespace to the schema in E.1." - which it does - but indirectly ;)

The important is to grant the compatibility with the OGC spec. So the solution with the extendedoperation is valid if it is compliant with the OGC xsd.

But the solution with the qgis namespace would be fine and valid - although it still might break clients.

| tested the "qgis" prefix solution instead of "sld" with XMLSPy.
Itis valid.

And francly, to update the own client from "sld" or "none" to "qgis" is really easy.
And to have a qgis-server compliant is more advantage for all.

So the correct should be:

<WMS_Capabilities xmIns:xsi="http://www.w3.0rg/2001/XMLSchema-instance" version="1.3.0" xmins="http://www.opengis.net/wms"
xsi:schemalocation="http://www.opengis.net/wms http://schemas.opengis.net/wms/1.3.0/capabilities_1_3_0.xsd http://www.opengis.net/sld
http://schemas.opengis.net/sld/1.1.0/sld_capabilities.xsd" xmIns:qgis="http://www.opengis.net/sld">

<qgis:GetLegendGraphic>
<Format>image/jpeg</Format>
<Format>image/png</Format>
<DCPType>
<HTTP>
<Get>
<OnlineResource xlink:type="simple" xmIns:xlink="...omissis..."/>
</Get>
</HTTP>
</DCPType>
</qgis:GetLegendGraphic>
this is the "ggis" namspace definition:

--> xmins:qgis="http://www.opengis.net/sld"

and the schemal.ocation:

should point also to the
http://schemas.opengis.net/sld/1.1.0/sld_capabilities.xsd

Regards,

#24 - 2014-06-07 03:00 PM - Jiirgen Fischer

aperi2007 - wrote:

| tested the "qgis" prefix solution instead of "sld" with XMLSPy.

It is valid.

Isn't the current solution "valid" for xmlspy too?

#25 - 2014-06-07 03:04 PM - Jiirgen Fischer

aperi2007 - wrote:

| tested the "qgis" prefix solution instead of "sld" with XMLSPy.

It is valid.

And does it also make ArcGIS 9.2 work for you?

#26 - 2014-06-07 03:33 PM - aperi2007 -

aperi2007 - wrote:

| tested the "qgis" prefix solution instead of "sld" with XMLSPy. It is valid.

Isn't the current solution "valid" for xmlspy too?

| tested it using the official and valid xsd from OGC.

The question is not only xmlispy.
| don't tested your solution, but | understand you point to another xsd that you have put on your site.

This xsd is not the official xsd.

| try to explain better:
Is it exactly equals to that from OGC ?
If yes why point it on your private site ?.

If you stop your site, the server response will become unvalidable.
if it is not equals to the official xsd , this mean you have chage something in the standard.

And surely the xmlspy will validable it.
But xmlspy don't know that the address you use is not the official url requested from the specs.

)

So you have a valid xml but absolutely no grant to be interoperable because you valid on a different xsd rather than the official.

#27 - 2014-06-07 05:32 PM - Jiirgen Fischer
aperi2007 - wrote:
The question is not only xmispy.
I think I fully understand your concerns. My question just is if there are any clients affected by this. | also don't know if there are actually clients (still)
relying on the current behaviour. Maybe other can comment on that.

For instance does ArcGIS 9.3 actually validate the schema, while 9.2 and 10.1 apparently don't? | suspect that 9.3 will still have problems even when the

validity issue is fixed.

| don't tested your solution, but | understand you point to another xsd that you have put on your site.

But the spec doesn't require that you use the xsd directly from OGC. It explicitly allows to use a copy:

| 7.2.4 GetCapabilities response

7.2.4.1 Introduction

When invoked on a WMS, the response to a GetCapabilities request shall be an XML document containing service metadata formatted according to
the XML Schema in E.1. The schema specifies the mandatory and optional content of the service metadata and how the content is formatted. The
XML document shall contain a root element named WMS_Capabilities in the “hitp://www.opengis.net/wms” namespace. This element shall contain
an XML Schema instance schemalocation attribute that binds the “http://www.opengis.net/wms” namespace to the schema in E.1. The schema
bound to the root attribute may be a copy of the schema in E.1 instead of the master copy at the URL stated in the annex provided none of the
normative content of the schema is changed. The schema copy shall be located at a fully-qualified and accessible URL to permit XML validating

software to retrieve it. The response shall be valid according to XML Schema validation rules.

It's explictly stated if extensions actually mean that "the normative content of the schema is changed" - as the spec explictly allows extensions and the
scheme is the OGC xsd + those extensions. The extensions usually are in an separate xsd (which with my limited xml knowledge always come with a

separate namespace), but "6.9.5 Extended capabilities and operations" also doesn't explictly requires that either.

#28 - 2014-06-07 10:55 PM - aperi2007 -
But the spec doesn't require that you use the xsd directly from OGC. It explicitly allows to use a copy:

Yes but is a technical need by the parser.

The parser "de facto" when parser using thexsd must download it.

Of course this mean that you could download it and put it on your site.

Must the spec explicitly DENY that you MODIFY IT and (perhaps) deny also the redistribute.
I don't know if the OGC licence deny the redistribution.

But surely the ISO organization (just as another example of the distributor of the WMS SPecs)
explixitly deny the redistribution of their XSD.

You can download but for your internal use only.

The two organization seem apparently tohave different logics but instead both have the same goal (objective) in mind

To have a GRANT that the user that download the xsd DON'T CHANGE something in it.

One say "you cannot change anythin" the other say "you cannot redistribute".
So avoid the confiusion.

Onestly if one has the xsd in its site, when has any problem is more easy to change a little row in it rather then
the change its code.

D)

So to point forward the original in the original site is like say
"l am compliant to the original specs as you can see".

Instaed point to a different site , a private site is like see

"My product work with my xsd. | hopeis equals to the original, but | dont know".

So | guess more better to point directly it.

Otherwise the QGIS himself has any risk that someone

could add new fetures and add them also to the xsd on it site.

No-one could detect this, the validation tets will pass , but was not autentically valid.

And when was discovered that the validity is FALSE the qgis credibility was definitively compromise.

Please notice:

| discovered the invalidity because | have a problem with our software and after a day spent to search the problem on out software | do a test on validity of
xml response of ggis.

The response was surprisly for me.

If you was using a xsd on your site that match fully the need of qgis.

The validity in the xmlspy was be passed, but also my software was still go in error because it wrong to parse the response because It dont know that there
is a GetPrint tag in that position.

And lost many more time to discovered it.

| guess this is a bad practice.l practice that | avoid because is dangerous and expose to future changing and waste of time to understand why that software
don't work with qgis-server.

#29 - 2014-06-08 02:07 AM - Jiirgen Fischer
aperi2007 - wrote:
| | But the spec doesn't require that you use the xsd directly from OGC. It explicitly allows to use a copy:
Yes but is a technical need by the parser.
The parser "de facto" when parser using the xsd must download it.
Of course this mean that you could download it and put it on your site.

Must the spec explicitly DENY that you MODIFY IT and (perhaps) deny also the redistribute.
I don't know if the OGC licence deny the redistribution.

Of course, that's what a spec is for. If you claim we are non-compliant back that up with a statement from the spec that we violate. We don't need to
assess Why a spec sets clear bounds in some areas and leaves room for interpretation in others - we just need to stay within the bounds it sets to be
compliant. According to the spec extensions are ok and pointing at different schema locations is ok unless "the normative content of the schema is
changed". | don't know if the there is an other part of the spec that elaborates what that quote actually supposed to mean and if aren't compliant to that,
but | don't see something in that quoted paragraph that we clearly violate.

I'm not saying that we are compliant, but | also don't say that we non-compliant. | don't know if we actually violate the spec. Sorry, but your general
remarks about generic standards don't help with that.

I'd also like do have direct answers to my questions about which clients you found being affected (you claimed ArcGIS 9.3 has problems, while | didn't find
problems with 9.2 and 10.1) and whether they are still affected and if those problems arise just from the capabilities being invalid or if those clients actually
can't cope with extensions, although they should when the schema includes any according to the spec. In the latter case we could - for the sake of
interoperability with non-compliant clients - maybe have an optional setting to avoid exposing the extensions. But as said earlier to be affected by this, a
client must validate the response (which most probably don't for performance reasons) and/or iterate the requests listing in capabilities and look for stuff

that it doesn't support, although that might make an otherwise perfectly usable service unusable.

What | want to know: which clients are affected by the current behaviour and which clients would be affected by a changes of the current behaviour
(extended requests without a prefix). You seem to avoid answering direct questions to that, | don't know and those who do might not be available until
after the pentecost weekend. So we probably just have to wait.

#30 - 2014-06-08 04:29 AM - Even Rouault

| agree with Jirgen that it is not completely clear what "The schema bound to the root attribute may be a copy of the schema in E.1

instead of the master copy at the URL stated in the annex provided none of the normative content of the schema is changed" really permits or bans. | think
the intent was that it was allowed to change comments and documentation (as stated in the intro paragraph of E.1), but perhaps not extending the schema
itself.

The way Inspire proceeds to extend WMS 1.3.0 can be a source of inspiration (pun intended ;-)) in that case.

For example, here's the beginning of the response of UMN MapServer to a GetCapabilities request to a project configured with Inspire extensions:
<WMS_Capabilities version="1.3.0"
xmins="http://www.opengis.net/wms"
xmins:sld="http://www.opengis.net/sld"
xmins:xsi="http://www.w3.0rg/2001/XMLSchema-instance"
xmins:ms="http://mapserver.gis.umn.edu/mapserver"
xmins:inspire_common="http://inspire.ec.europa.eu/schemas/common/1.0"
xmins:inspire_vs="http://inspire.ec.europa.eu/schemas/inspire_vs/1.0"
xsi:schemalocation="http://www.opengis.net/wms http://schemas.opengis.net/wms/1.3.0/capabilities_1_3_0.xsd
http://www.opengis.net/sld http://schemas.opengis.net/sld/1.1.0/sld_capabilities.xsd
http://inspire.ec.europa.eu/schemas/inspire_vs/1.0 http://inspire.ec.europa.eu/schemas/inspire_vs/1.0/inspire_vs.xsd
http://mapserver.gis.umn.edu/mapserver
http://www.geodaten-mv.de/dienste/inspirevs_test?language=ger&amp;service=WMS&amp;version=1.3.0&amp;request=GetSchemaExtension">

and later in the doc :

<inspire_vs:ExtendedCapabilities>

<inspire_common:MetadataUrl xsi:type="inspire_common:resourceLocator Type">

<inspire_common:URL>http://www.geodaten-mv.de/soapServices/CSWStartup?service=CSW&amp;version=2.0.2&amp;request=GetRecordByld&amp;output
&amp;outputSchema=http://www.isotc211.0rg/2005
/gmd&amp;ElementSetName=Ffull&amp;ld=4d5f1402-5b2b-43ec-949f-92d125179318</inspire_common:URL>
<inspire_common:MediaType>application/vnd.ogc.csw.capabilities.response_xml</inspire_common:MediaType>
</inspire_common:MetadataUrl>
<inspire_common:SupportedLanguages>

<inspire_common:DefaultLanguage><inspire_common:Language>ger</inspire_common:Language></inspire_common:DefaultLanguage>

<inspire_common:SupportedLanguage><inspire_common:Language>eng</inspire_common:Language></inspire_common:SupportedLanguage>

</inspire_common:SupportedLanguages>

<inspire_common:ResponselLanguage><inspire_common:Language>ger</inspire_common:Language></inspire_common:ResponselLanguage>

</inspire_vs:ExtendedCapabilities>

The http://inspire.ec.europa.eu/schemas/inspire vs/1.0/inspire vs.xsd schema is :

<schema xmins:inspire_vs="http://inspire.ec.europa.eu/schemas/inspire_vs/1.0"
xmins:inspire_common="http://inspire.ec.europa.eu/schemas/common/1.0" xmIns:wms="http://www.opengis.net/wms"
xmins="http://www.w3.0rg/2001/XMLSchema" xmins:xlink="http://www.w3.0rg/1999/xlink"
targetNamespace="http://inspire.ec.europa.eu/schemas/inspire_vs/1.0" elementFormDefault="qualified" attributeFormDefault="unqualified"
version="1.0.1">

<import namespace="http://www.opengis.net/wms" schemal ocation="http://schemas.opengis.net/wms/1.3.0/capabilities_1_3_0.xsd"/>

<import namespace="http://inspire.ec.europa.eu/schemas/common/1.0" schemalocation="../...common/1.0/common.xsd"/>

<element name="ExtendedCapabilities" type="inspire_common:ExtendedCapabilitiesType" substitutionGroup="wms:_ExtendedCapabilities"/>

</schema>

#31 - 2014-06-09 06:31 AM - Giovanni Manghi
- Category set to QGIS Server

#32 - 2014-06-11 02:55 AM - Jiirgen Fischer
- Priority changed from Severe/Regression to High

#33 - 2014-06-20 02:06 PM - Paolo Cavallini

- Subject changed from QGIS Server getcapabilites response is not WMS compliant ! to QGIS Server getcapabilites response is not WMS compliant

#34 - 2014-12-01 01:31 PM - René-Luc ReLuc

- Pull Request or Patch supplied changed from No to Yes
- Assignee set to Marco Hugentobler

- Target version set to Version 2.8

Pull request supplied
https://github.com/qgis/QGIS/pull/1715

#35 - 2014-12-04 11:58 PM - Marco Hugentobler

- Status changed from In Progress to Closed

Fixed in changeset commit:"072c1e573179727{8d1092f3c9b37d0e99c855a2".
